## org.apache.mahout.math.set
Class OpenIntHashSet

    java.lang.Object
      org.apache.mahout.math.PersistentObject
          org.apache.mahout.math.set.AbstractSet
              org.apache.mahout.math.set.AbstractIntSet
                  org.apache.mahout.math.set.OpenIntHashSet

All Implemented Interfaces:
  Serializable, Cloneable

    public class OpenIntHashSet

extends AbstractIntSet

Open hash set of int items;

See Also:
  Serialized Form

Field Summary
`protected static byte` `FREE`
`protected static byte` `FULL`
`protected static int` `NO_KEY_VALUE`
`protected static byte` `REMOVED`

Fields inherited from class org.apache.mahout.math.set.AbstractSet
`DEFAULT_CAPACITY, DEFAULT_MAX_LOAD_FACTOR, DEFAULT_MIN_LOAD_FACTOR, distinct, highWaterMark, lowWaterMark, maxLoadFactor, minLoadFactor`

Constructor Summary
`OpenIntHashSet()` Constructs an empty map with default capacity and default load factors.
`OpenIntHashSet(int initialCapacity)` Constructs an empty map with the specified initial capacity and default load factors.
`OpenIntHashSet(int initialCapacity, double minLoadFactor, double maxLoadFactor)` Constructs an empty map with the specified initial capacity and the specified minimum and maximum load factor.

Method Summary
`boolean` `add(int key)` Associates the given key with the given value.
`void` `clear()` Removes all values associations from the receiver.
`Object` `clone()` Returns a deep copy of the receiver.
`boolean` `contains(int key)` Returns `true` if the receiver contains the specified key.
`void` `ensureCapacity(int minCapacity)` Ensures that the receiver can hold at least the specified number of associations without needing to allocate new internal memory.
`boolean` `forEachKey(IntProcedure procedure)` Applies a procedure to each key of the receiver, if any.
`protected void` `getInternalFactors(int[] capacity, double[] minLoadFactor, double[] maxLoadFactor)` Access for unit tests.
`protected int` `indexOfInsertion(int key)`
`protected int` `indexOfKey(int key)`
`void` `keys(IntArrayList list)` Fills all keys contained in the receiver into the specified list.
`protected void` `rehash(int newCapacity)` Rehashes the contents of the receiver into a new table with a smaller or larger capacity.
`boolean` `remove(int key)` Removes the given key with its associated element from the receiver, if present.
`protected void` `setUp(int initialCapacity, double minLoadFactor, double maxLoadFactor)` Initializes the receiver.
`void` `trimToSize()` Trims the capacity of the receiver to be the receiver's current size.

Methods inherited from class org.apache.mahout.math.set.AbstractIntSet
`copy, equals, hashCode, keys, toString`

Methods inherited from class org.apache.mahout.math.set.AbstractSet
`chooseGrowCapacity, chooseHighWaterMark, chooseLowWaterMark, chooseMeanCapacity, chooseShrinkCapacity, equalsMindTheNull, isEmpty, nextPrime, size`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### FREE

    protected static final byte FREE

See Also:
  Constant Field Values

### FULL

    protected static final byte FULL

See Also:
  Constant Field Values

### REMOVED

    protected static final byte REMOVED

See Also:
  Constant Field Values

### NO_KEY_VALUE

    protected static final int NO_KEY_VALUE

See Also:
  Constant Field Values

Constructor Detail

### OpenIntHashSet

    public OpenIntHashSet()

  Constructs an empty map with default capacity and default load factors.

### OpenIntHashSet

    public OpenIntHashSet(int initialCapacity)

  Constructs an empty map with the specified initial capacity and default load factors.

  Parameters:
    `initialCapacity` - the initial capacity of the map.
  Throws:
    `IllegalArgumentException` - if the initial capacity is less than zero.

### OpenIntHashSet

    public OpenIntHashSet(int initialCapacity,
                          double minLoadFactor,
                          double maxLoadFactor)

  Constructs an empty map with the specified initial capacity and the specified minimum and maximum load factor.

  Parameters:
    `initialCapacity` - the initial capacity.
    `minLoadFactor` - the minimum load factor.
    `maxLoadFactor` - the maximum load factor.
  Throws:
    `IllegalArgumentException` - if `initialCapacity < 0 || (minLoadFactor < 0.0 || minLoadFactor >= 1.0) || (maxLoadFactor <= 0.0 || maxLoadFactor >= 1.0) || (minLoadFactor >= maxLoadFactor)`.

Method Detail

### clear

    public void clear()

  Removes all values associations from the receiver. Implicitly calls `trimToSize()`.

  Specified by:
    `clear` in class `AbstractSet`

### clone

    public Object clone()

  Returns a deep copy of the receiver.

  Overrides:
    `clone` in class `PersistentObject`
  Returns:
    a deep copy of the receiver.

### contains

    public boolean contains(int key)

  Returns `true` if the receiver contains the specified key.

  Overrides:
    `contains` in class `AbstractIntSet`
  Returns:
    `true` if the receiver contains the specified key.

### ensureCapacity

    public void ensureCapacity(int minCapacity)

  Ensures that the receiver can hold at least the specified number of associations without needing to allocate new internal memory. If necessary, allocates new internal memory and increases the capacity of the receiver.

  This method never need be called; it is for performance tuning only. Calling this method before `add()`ing a large number of associations boosts performance, because the receiver will grow only once instead of potentially many times and hash collisions get less probable.

  Overrides:
    `ensureCapacity` in class `AbstractSet`
  Parameters:
    `minCapacity` - the desired minimum capacity.

### forEachKey

    public boolean forEachKey(IntProcedure procedure)

  Applies a procedure to each key of the receiver, if any. Note: Iterates over the keys in no particular order. Subclasses can define a particular order, for example, "sorted by key". All methods which can be expressed in terms of this method (most methods can) must guarantee to use the same order defined by this method, even if it is no particular order. This is necessary so that, for example, methods `keys` and `values` will yield association pairs, not two uncorrelated lists.

  Specified by:
    `forEachKey` in class `AbstractIntSet`
  Parameters:
    `procedure` - the procedure to be applied. Stops iteration if the procedure returns `false`, otherwise continues.
  Returns:
    `false` if the procedure stopped before all keys where iterated over, `true` otherwise.

### indexOfInsertion

    protected int indexOfInsertion(int key)

  Parameters:
    `key` - the key to be added to the receiver.
  Returns:
    the index where the key would need to be inserted, if it is not already contained. Returns -index-1 if the key is already contained at slot index. Therefore, if the returned index < 0, then it is already contained at slot -index-1. If the returned index >= 0, then it is NOT already contained and should be inserted at slot index.

### indexOfKey

    protected int indexOfKey(int key)

  Parameters:
    `key` - the key to be searched in the receiver.
  Returns:
    the index where the key is contained in the receiver, returns -1 if the key was not found.

### keys

    public void keys(IntArrayList list)

  Fills all keys contained in the receiver into the specified list. Fills the list, starting at index 0. After this call returns the specified list has a new size that equals `this.size()`. Iteration order is guaranteed to be identical to the order used by method `forEachKey(IntProcedure)`.

  This method can be used to iterate over the keys of the receiver.

  Overrides:
    `keys` in class `AbstractIntSet`
  Parameters:
    `list` - the list to be filled, can have any size.

### add

    public boolean add(int key)

  Associates the given key with the given value. Replaces any old `(key,someOtherValue)` association, if existing.

  Specified by:
    `add` in class `AbstractIntSet`
  Parameters:
    `key` - the key the value shall be associated with.
  Returns:
    `true` if the receiver did not already contain such a key; `false` if the receiver did already contain such a key - the new value has now replaced the formerly associated value.

### rehash

    protected void rehash(int newCapacity)

  Rehashes the contents of the receiver into a new table with a smaller or larger capacity. This method is called automatically when the number of keys in the receiver exceeds the high water mark or falls below the low water mark.

### remove

    public boolean remove(int key)

  Removes the given key with its associated element from the receiver, if present.

  Specified by:
    `remove` in class `AbstractIntSet`
  Parameters:
    `key` - the key to be removed from the receiver.
  Returns:
    `true` if the receiver contained the specified key, `false` otherwise.

### setUp

    protected final void setUp(int initialCapacity,
                               double minLoadFactor,
                               double maxLoadFactor)

  Initializes the receiver.

  Overrides:
    `setUp` in class `AbstractSet`
  Parameters:
    `initialCapacity` - the initial capacity of the receiver.
    `minLoadFactor` - the minLoadFactor of the receiver.
    `maxLoadFactor` - the maxLoadFactor of the receiver.
  Throws:
    `IllegalArgumentException` - if `initialCapacity < 0 || (minLoadFactor < 0.0 || minLoadFactor >= 1.0) || (maxLoadFactor <= 0.0 || maxLoadFactor >= 1.0) || (minLoadFactor >= maxLoadFactor)`.

### trimToSize

    public void trimToSize()

  Trims the capacity of the receiver to be the receiver's current size. Releases any superfluous internal memory. An application can use this operation to minimize the storage of the receiver.

  Overrides:
    `trimToSize` in class `AbstractSet`

### getInternalFactors

    protected void getInternalFactors(int[] capacity,
                                      double[] minLoadFactor,
                                      double[] maxLoadFactor)

  Access for unit tests.

  Parameters:
    `capacity` -
    `minLoadFactor` -
    `maxLoadFactor` -

Copyright © 2008–2014 The Apache Software Foundation. All rights reserved.